"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LeafBlock = void 0;
const printTree_1 = require("tree-dump/lib/printTree");
const Block_1 = require("./Block");
class LeafBlock extends Block_1.Block {
    // ---------------------------------------------------------------- Printable
    toStringHeader() {
        const str = this.text();
        const truncate = str.length > 32;
        const text = JSON.stringify(truncate ? str.slice(0, 32) : str) + (truncate ? ' …' : '');
        const header = `${super.toStringHeader()} ${text}`;
        return header;
    }
    toString(tab = '') {
        const header = this.toStringHeader();
        const texts = [...this.texts()];
        const hasSlices = !!texts.length;
        return (header +
            (0, printTree_1.printTree)(tab, [
                this.marker ? (tab) => this.marker.toString(tab) : null,
                !hasSlices
                    ? null
                    : (tab) => 'nodes' +
                        (0, printTree_1.printTree)(tab, texts.map((inline) => (tab) => inline.toString(tab))),
            ]));
    }
}
exports.LeafBlock = LeafBlock;
