"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditorSlices = void 0;
const PersistedSlice_1 = require("../slice/PersistedSlice");
class EditorSlices {
    constructor(txt, slices) {
        this.txt = txt;
        this.slices = slices;
    }
    insAtCursors(callback) {
        const slices = [];
        this.txt.editor.cursors((cursor) => {
            const slice = callback(cursor);
            slices.push(slice);
        });
        return slices;
    }
    insStack(type, data) {
        return this.insAtCursors((cursor) => this.slices.insStack(cursor.range(), type, data));
    }
    insOverwrite(type, data) {
        return this.insAtCursors((cursor) => this.slices.insOverwrite(cursor.range(), type, data));
    }
    insErase(type, data) {
        return this.insAtCursors((cursor) => this.slices.insErase(cursor.range(), type, data));
    }
    insMarker(type, data, separator) {
        return this.insAtCursors((cursor) => {
            cursor.collapse();
            const after = cursor.start.clone();
            after.refAfter();
            const marker = this.slices.insMarkerAfter(after.id, type, data, separator);
            return marker;
        });
    }
    del(sliceOrId) {
        this.slices.del(sliceOrId instanceof PersistedSlice_1.PersistedSlice ? sliceOrId.id : sliceOrId);
    }
}
exports.EditorSlices = EditorSlices;
