import { OverlayPoint } from './OverlayPoint';
import type { HeadlessNode2 } from 'sonic-forest/lib/types2';
import type { SliceType } from '../slice/types';
import type { Anchor } from '../rga/constants';
import type { AbstractRga } from '../../../json-crdt/nodes/rga';
import type { ITimestampStruct } from '../../../json-crdt-patch/clock';
import type { MarkerSlice } from '../slice/MarkerSlice';
export declare class MarkerOverlayPoint<T = string> extends OverlayPoint<T> implements HeadlessNode2 {
    protected readonly rga: AbstractRga<T>;
    readonly marker: MarkerSlice<T>;
    /**
     * Hash value of the following text contents, up until the next marker.
     */
    textHash: number;
    constructor(rga: AbstractRga<T>, id: ITimestampStruct, anchor: Anchor, marker: MarkerSlice<T>);
    type(): SliceType;
    data(): unknown;
    toStringName(tab: string, lite?: boolean): string;
    toString(tab?: string, lite?: boolean): string;
    p2: MarkerOverlayPoint<T> | undefined;
    l2: MarkerOverlayPoint<T> | undefined;
    r2: MarkerOverlayPoint<T> | undefined;
}
