"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateType = void 0;
const validateType = (type) => {
    switch (typeof type) {
        case 'string':
        case 'number':
            return;
        case 'object': {
            if (!(type instanceof Array))
                throw new Error('INVALID_TYPE');
            if (type.length > 32)
                throw new Error('INVALID_TYPE');
            const length = type.length;
            LOOP: for (let i = 0; i < length; i++) {
                const step = type[i];
                switch (typeof step) {
                    case 'string':
                    case 'number':
                        continue LOOP;
                    default:
                        throw new Error('INVALID_TYPE');
                }
            }
            return;
        }
        default:
            throw new Error('INVALID_TYPE');
    }
};
exports.validateType = validateType;
