"use strict";
/**
 * Implements JSON CRDT Patch codec for JSON serialization format, which is
 * a verbose human-readable format designed for debugging and testing.
 *
 * This module encodes the {@link Patch} into a JavaScript POJO. You can then use
 * any JSON serializer to serialize the POJO into a string or a binary format.
 *
 * Usage:
 *
 * ```ts
 * const encoded = JSON.stringify(encode(patch));
 * const decoded = decode(JSON.parse(encoded));
 * ```
 *
 * @module json-crdt-patch/codec/json
 */
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
tslib_1.__exportStar(require("./types"), exports);
tslib_1.__exportStar(require("./encode"), exports);
tslib_1.__exportStar(require("./decode"), exports);
