"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.logDecoderOpts = void 0;
const Decoder_1 = require("../../codec/sidecar/binary/Decoder");
const Decoder_2 = require("../../codec/structural/compact/Decoder");
const Decoder_3 = require("../../codec/structural/verbose/Decoder");
const JsonDecoder_1 = require("@jsonjoy.com/json-pack/lib/json/JsonDecoder");
const CborDecoder_1 = require("@jsonjoy.com/json-pack/lib/cbor/CborDecoder");
const decode_1 = require("../../../json-crdt-patch/codec/compact/decode");
const decode_2 = require("../../../json-crdt-patch/codec/verbose/decode");
/**
 * Default {@link LogDecoderOpts} for {@link LogDecoder}. Instantiates all
 * possible decoders.
 */
exports.logDecoderOpts = {
    jsonDecoder: new JsonDecoder_1.JsonDecoder(),
    cborDecoder: new CborDecoder_1.CborDecoder(),
    structuralCompactDecoder: new Decoder_2.Decoder(),
    structuralVerboseDecoder: new Decoder_3.Decoder(),
    sidecarDecoder: new Decoder_1.Decoder(),
    patchCompactDecoder: decode_1.decode,
    patchVerboseDecoder: decode_2.decode,
};
