"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.logEncoderOpts = void 0;
const Writer_1 = require("@jsonjoy.com/util/lib/buffers/Writer");
const Encoder_1 = require("../../codec/sidecar/binary/Encoder");
const Encoder_2 = require("../../codec/structural/compact/Encoder");
const Encoder_3 = require("../../codec/structural/verbose/Encoder");
const encode_1 = require("../../../json-crdt-patch/codec/compact/encode");
const encode_2 = require("../../../json-crdt-patch/codec/verbose/encode");
const CborEncoder_1 = require("@jsonjoy.com/json-pack/lib/cbor/CborEncoder");
const JsonEncoder_1 = require("@jsonjoy.com/json-pack/lib/json/JsonEncoder");
const writer = new Writer_1.Writer(4096);
/**
 * Default {@link LogEncoderOpts} for {@link LogEncoder}. Instantiates all
 * possible encoders.
 */
exports.logEncoderOpts = {
    jsonEncoder: new JsonEncoder_1.JsonEncoder(writer),
    cborEncoder: new CborEncoder_1.CborEncoder(writer),
    structuralCompactEncoder: new Encoder_2.Encoder(),
    structuralVerboseEncoder: new Encoder_3.Encoder(),
    sidecarEncoder: new Encoder_1.Encoder(),
    patchCompactEncoder: encode_1.encode,
    patchVerboseEncoder: encode_2.encode,
};
