/**
 * Represents an expression {@link types.Expr} which was evaluated by codegen and
 * which value is already know at compilation time, hence it can be emitted
 * as a literal.
 */
export declare class Literal {
    val: unknown;
    constructor(val: unknown);
    toString(): string;
}
/**
 * Represents an expression {@link types.Expr} which was evaluated by codegen and
 * which value is not yet known at compilation time, hence its value will
 * be evaluated at runtime.
 */
export declare class Expression {
    val: string;
    constructor(val: string);
    toString(): string;
}
export type ExpressionResult = Literal | Expression;
